{ ------------------------------------------------------------------
  Unit           : mdString
  By             : Martin Djerns
  Changed        : 2 March 1997 - MD
  Changed        : 7 April 1997 - MD
  ------------------------------------------------------------------
  String functions for PChar and Pascal type strings
  ------------------------------------------------------------------
  I take no responsibility for problemes, errors or failures caused
  direct or inderectly by this module.
  The module is free to use, copy and distribute, but is is NOT
  allowed to change enything without permission from the author.
  ------------------------------------------------------------------
   Copyright 1997 by Martin Djerns
  ------------------------------------------------------------------ }
unit Mdstring;

interface

Uses
  SysUtils;

Function StrGetField(InStr : PChar;Separator : Char;Number : Integer) : PChar;
Function GetField(Const InStr : String; Number : Integer) : String;
Function GetCharField(InStr : String;Ch : Char; Number : Integer) : String;
Function StrPCat(P : PChar; Const S : String) : PChar;
Function StrClear(P : PChar) : PChar;
Function CommaCount( Const Str : String) : Byte;
Function CharCount(Ch : Char; Const Str : String) : Byte;
{$IFNDEF WIN32}
Procedure SetLength(Var S : String; Length : Byte);
{$ENDIF}
Function StrPNew(Const S : String) : PChar;
implementation

{A call to StrGetField should have a following fields as argument}
{In text                                       : PChar}
{Char which seperate the fields                : Char}
{The field number (0 = before first separator) : Integer}
{The function will return an empty strng (#0) if there is no result}
{The target PChar should not be allocated before call,}
{but it should be released with StrDispose}
Function StrGetField(InStr : PChar;Separator : Char;Number : Integer) : PChar;
Var
  Field, Len : Integer;
Begin
  Result := NIL;                     {Avoid a MISC result}
  If InStr = NIL Then                {If there is no In string}
    Exit;

  If Number < 0 Then
    Len := StrLen(InStr) - 1
  else
    Len := 0;
    Field := 0;
If (NOT ((Number = -1) OR (Number = 0))) OR
        (InStr[Len] <> Separator)  Then
  While (Field <> Number) AND        {Find the right field}
        ((Number >= 0) AND (InStr[Len] <> #0) OR
        ((Number < 0) AND (Len > 0)))
        do
  Begin
    If (InStr[Len] = Separator) Then
      If Number < 0 Then
        Dec(Field)
      else
        Inc(Field);
    If Number < 0 Then
      Dec(Len)
    else
      Inc(Len);
  end;

  If (Number < 0) Then
//    If (Len = 0) Then
//      Dec(Field)
//    else
    If (Len <> 0) Then
      Inc(Len,2);

  If Len <> 0 Then
    Inc(LongInt(InStr),Len);       {Move pointer to start of field}
  Len := 0;
                                     {Calculate length of field}
  While (InStr[Len] <> Separator) AND
        (InStr[Len] <> #0) DO
    Inc(Len);
  Result := StrAlloc(Len+1);         {Get mem for result}
  FillChar(Result^,Len+1,#0);        {Initer so ther wont come errors}
  StrLCopy(Result,InStr,Len);        {Copy the text to result}
end;

Function GetCharField(InStr : String; Ch : Char; Number : Integer) : String;
Var
  Buffer : PChar;
Begin
  Result := '';
  If Length(InStr) = 255 Then Exit;  {MaxLength of string}
  InStr := InStr + #0;
  Buffer := StrGetField(@InStr[1],Ch,Number);
  If Buffer <> NIL Then
  Begin
    Result := StrPas(Buffer);
    StrDispose(Buffer);
  end;
end;

Function GetField(Const InStr : String; Number : Integer) : String;
Begin
  Result := GetCharField(InStr, ',', Number);
end;

Function StrPCat(P : PChar; Const S : String) : PChar;
Var
  Len,
  Counter : Byte;
Begin
  Len := StrLen(P) - 1;
  For Counter := 1 To Length(S) do
    P[Len+Counter] := S[Counter];
  Result := P;
end;

Function StrClear(P : PChar) : PChar;
Begin
  Result := P;
  If P = NIL Then Exit;
  FillChar(P^,StrBufSize(P),#0);
end;

Function CharCount(Ch : Char; Const Str : String) : Byte;
Var
  Counter : Byte;
Begin
  Result := 0;
  For Counter := 1 to length(Str) do
    If Str[Counter] = Ch Then
      Inc(result);
end;

Function CommaCount(Const Str : String) : Byte;
Begin
  Result := CharCount(',', Str);
end;

{$IFNDEF WIN32}
Procedure SetLength(Var S : String; Length : Byte);
Begin
  S[0] := Char(Length);
end;
{$ENDIF}

Function StrPNew(Const S : String) : PChar;
Begin
  Result := StrAlloc(Length(S)+1);
  StrPCopy(Result,S+#0);
end;

end.
